display_experiments_url="/experiments/api/display_experiments"
get_exp_details_url="/experiments/api/get_experiment_details"
var experiments_source =
{
    datatype: "json",
    datafields: [
        { name: 'filename', type: 'string' },
        { name: 'description', type: 'string' },
        { name: 'type', type: 'string' },
        { name: 'creation_time', type: 'date' },
        { name: 'last_update_time', type: 'date' },
        { name: 'tag', type: 'string' }
    ],
    url: display_experiments_url
};
var experiments_dataAdapter = new $.jqx.dataAdapter(experiments_source);

function display_experiments_list() {
    $("#appWorkspace").append('<div id="experiments_grid" bp="12"></div>')
    $("#experiments_grid").jqxGrid({
        width: "98%",
        autoheight: true,
        sortable: true,
        filterable: true,
        pageable: true,
        pagesizeoptions: ['15', '20', '25', '50'],
        pagesize: 20,
        source: experiments_dataAdapter,
        selectionmode: 'singlerow',
        columns: [
            { text: 'Filename', datafield: 'filename', width: "30%" },
            { text: 'Description', datafield: 'description', width: "20%" },
            { text: 'Type', datafield: 'type', width: "10%" },
            { text: 'Tag', datafield: 'tag', width: "20%" },
            { text: 'Creation time', datafield: 'creation_time', cellsformat: 'yyyy-MM-dd HH:mm', width: "10%" },
            { text: 'Last Updated', datafield: 'last_update_time', cellsformat: 'yyyy-MM-dd HH:mm', width: "10%" }
        ]
    });

    $('#experiments_grid').on('rowselect', function (event) {
        var args = event.args;
        var row = args.row;
        console.log("Exp. filename: "+row.filename);
        console.log("Exp. type "+row.type);
        display_experiment_details(row.filename, row.type);
    });
};

function display_experiment_details(filename, type) {
    $.getJSON( get_exp_details_url, {filename: filename, type: type}, function( d ) {
        console.log(d)
        if (Object.keys(d).length > 0) {
            $("#appWorkspace").append('<div id="exp_window"><div><p class="capitalize">'+type+' '+filename+' details</p></div></div>');

            var ribbon_elem='<div id="exp_details_ribbon" ><ul>'
            for (var key in d) {
                ribbon_elem += '<li>'+key+'</li>'
            }
            ribbon_elem += '</ul>'
            ribbon_elem += '<div>'
            for (var key in d) {
                ribbon_elem += '<div>'+d[key]+'</div>'
            }
            ribbon_elem += '</div>'
            ribbon_elem += '</div>'
            $("#exp_window").append(ribbon_elem);
            $('#exp_details_ribbon').jqxRibbon({width: "100%", height: "100%", mode: "default"});
            $('#exp_window').jqxWindow({
                width: 800,
                height: 500,
                position:'top, right',
                resizable: true,
                isModal: true,
                closeButtonAction:'close'
            });
            $('#exp_details_ribbon').jqxRibbon('render');
            $('#exp_window').on('close', function (event) {
                $('#experiments_grid').jqxGrid('clearselection');
                $('#exp_window').remove();
            });
        };
    });
};


var properties = [
    'exp_id',
    'schedule',
    'start_time',
    'end_time',
    'status'
];

$.each( properties, function( i, val ) {
	
	var orderClass = '';

	$("#" + val).click(function(e){
		e.preventDefault();
		$('.filter__link.filter__link--active').not(this).removeClass('filter__link--active');
  		$(this).toggleClass('filter__link--active');
   		$('.filter__link').removeClass('asc desc');

   		if(orderClass == 'desc' || orderClass == '') {
    			$(this).addClass('asc');
    			orderClass = 'asc';
       	} else {
       		$(this).addClass('desc');
       		orderClass = 'desc';
       	}

		var parent = $(this).closest('.header__item');
    		var index = $(".header__item").index(parent);
		var $table = $('.table-content');
		var rows = $table.find('.table-row').get();
		var isSelected = $(this).hasClass('filter__link--active');
		var isNumber = $(this).hasClass('filter__link--number');
			
		rows.sort(function(a, b){

			var x = $(a).find('.table-data').eq(index).text();
    			var y = $(b).find('.table-data').eq(index).text();
				
			if(isNumber == true) {
    					
				if(isSelected) {
					return x - y;
				} else {
					return y - x;
				}

			} else {
			
				if(isSelected) {		
					if(x < y) return -1;
					if(x > y) return 1;
					return 0;
				} else {
					if(x > y) return -1;
					if(x < y) return 1;
					return 0;
				}
			}
    		});

		$.each(rows, function(index,row) {
			$table.append(row);
		});

		return false;
	});

});
